;; -*-emacs-lisp-*-
;;
;; Emacs startup file for the Debian GNU/Linux dpkg-dev-el package

(if (not (file-exists-p "/usr/share/emacs/site-lisp/dpkg-dev-el"))
    (message "Package dpkg-dev-el removed but not purged.  Skipping setup.")

  (debian-pkg-add-load-path-item
   (concat "/usr/share/"
           (symbol-name debian-emacs-flavor)
           "/site-lisp/dpkg-dev-el"))

  (require 'dpkg-dev-el)

  ;; other useful automode
  (add-to-list 'auto-mode-alist
               '("/debian/[^/]*emacsen-startup\\'" . emacs-lisp-mode))

  (when (member 'utf-8 (coding-system-list))
    ;; default to utf-8 for debian changelog files
    (modify-coding-system-alist 'file "/changelog\\.Debian\\'" 'utf-8)
    (modify-coding-system-alist 'file "/debian/changelog\\'" 'utf-8)
    
    ;; Handle Debian native package, from Kevin Ryde in bug #317597
    (defun debian-changelog-coding-system (args)
      "Return the coding system for a /usr/share/doc/[package]/changelog file.
If [package] is a debian native (no separate changelog.Debian) then answer
`utf-8', otherwise remove ourselves from `file-coding-system-alist' and see
what other rules say."
      (let ((dirname (file-name-directory (cadr args))))
        (if (file-exists-p (concat dirname "changelog.Debian.gz"))
            (let ((file-coding-system-alist
                   (remove '("/usr/share/doc/[^/]+/changelog\\'"
                             . debian-changelog-coding-system)
                           file-coding-system-alist)))
              (apply 'find-operation-coding-system args))
          'utf-8)))
    
    (modify-coding-system-alist 'file "/usr/share/doc/[^/]+/changelog\\'"
                                'debian-changelog-coding-system)))
